// CPConvTst.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

typedef CPCONVERT_API int (*pfnCPConvert)(int nCPFrom, int nCPTo, LPCTSTR lpszFrom, LPTSTR lpszTo, int nLenOut);

const int MAXSTRSIZE = 256;
LPCTSTR HELLOWORD = _T(" !");
pfnCPConvert pCPConvert = NULL;

int main(int argc, char* argv[])
{
	HINSTANCE  hLibrary = NULL;
	hLibrary = LoadLibrary("CPConvert.dll");
	if (hLibrary == NULL)
	{
		cout << "Error on LoadLibrary: CPConvert.dll" << endl;
		return 1;
	}

	pCPConvert = (pfnCPConvert)GetProcAddress(hLibrary, "CPConvert");
	if (pCPConvert == NULL)
	{
		FreeLibrary(hLibrary);
  		cout << "Error on GetProcAddress: CPConvert()" << endl;
		return 1;
	}

    _TCHAR szStrOut[MAXSTRSIZE];
	int nSize = 0;
	// Russian windows -> Russian DOS
	nSize = (*pCPConvert)(1251, 866, HELLOWORD, szStrOut, MAXSTRSIZE);
	cout << _T("1251->866 : ") << szStrOut << endl;
	
	// Russian windows -> koi8-r
	nSize = (*pCPConvert)(1251, 20866, HELLOWORD, szStrOut, MAXSTRSIZE);
	cout << _T("1251->20866 : ") << szStrOut << endl;
	
	// Russian windows -> Error CP
	nSize = (*pCPConvert)(1251, 111, HELLOWORD, szStrOut, MAXSTRSIZE);
	cout << _T("1251->111 : ") << szStrOut << endl;
	
	pCPConvert = NULL;
	FreeLibrary(hLibrary);
	return 0;
}

